routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route Categories
Route::resource('Categories', 'Categories\CategoriesController')->middleware('auth');
Route::resource('user', 'Users\UserController')->middleware('auth');
Route::resource('products', 'Products\ProductController')->middleware('auth');

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Models/Categories/Categories.php
<?php

namespace App\Models\Categories;

use Illuminate\Database\Eloquent\Model;

class Categories extends Model
{
    // se envian por medio de un array los datos que se quieren llenar
    protected $fillable=['name', 'description', 'user_id'];
}

app/Http/Controllers/Categories/CategoriesController.php
<?php

namespace App\Http\Controllers\Categories;

use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Alert;
use App\Http\Controllers\Controller;
use App\Models\Categories\Categories;


class CategoriesController extends Controller
{

    // middleware para que solo deje pasar a las vistas los usuarios autenticados
    // public function __construct()
    // {
    //     $this->middleware('auth');
    // }


    //Display a listing of the resource.
    public function index()
    {
        $categories=Categories::orderBy('id', 'DESC')->paginate(10);
        return view('categories.index', compact('categories'));
    }

    //Show the form for creating a new resource.
    public function create()
    {
        //
        return view('Categories.create');
    }


    //Store a newly created resource in storage.
    public function store(Request $request)
    {
        //
        $this->validate($request, [
            'name'=> ['required','unique:categories'],
            'description'=> ['required']]);



        $datos=collect($request->all());
        $datos->put('user_id',Auth::id());
        Categories::create($datos->toArray());
        alert()->success('Success Message', 'Registro creado con éxito')->autoclose(3500);
        return redirect()->route('Categories.index');
    }


    //Display the specified resource.
    public function show($id)
    {
        $categories=Categories::find($id);
        return view('categories.show',compact('categories'));
    }


    //Show the form for editing the specified resource.
    public function edit($id)
    {
        //
        $categories=Categories::find($id);
        return view('categories.edit', compact('categories'));
    }


    //Update the specified resource in storage.
      public function update(Request $request, $id)
    {
        //
        $this->validate($request, [
            'name'=> ['required',
            Rule::unique('categories', 'name')->ignore($id),
        ],
            'description'=> ['required']]);


        Categories::find($id)->update($request->all());
        alert()->success('Success Message', 'Registro modificado con éxito')->autoclose(3500);
        return redirect()->route('Categories.index');
    }

   
    //Remove the specified resource from storage.
    public function destroy($id)
    {
        //
        Categories::find($id)->delete();
        alert()->success('Success Message', 'Registro Eliminado Correctamente')->autoclose(3500);
        return redirect()->route('Categories.index');
    }
}

resources/views/categories/edit.blade.php
@extends('layouts.app')
@section('content')

<div class="container">
  <div class="row justify-content-center">
    <div class="col-md-6">
      <div class="card o-hidden border-0 shadow-lg my-5">
        <div class="card-header">Actualizar Categoría</div>
        <div class="card-body">
          <form method="POST" action="{{ route('Categories.update',$categories->id) }}"  role="form">
           {{ csrf_field() }}
           <input name="_method" type="hidden" value="PATCH"> 

            <div class="form-group row">
                <label for="name" class="col-md-4 col-form-label text-md-right">Nombre<span class="required" style="color:red">*</span></label>

                <div class="col-md-6">
                    <input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{$categories->name}}" required autocomplete="name" autofocus>

                    @error('name')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>

             <div class="form-group row">
                <label for="name" class="col-md-4 col-form-label text-md-right">Descripcion<span class="required" style="color:red">*</span></label>

                <div class="col-md-6">
                    <textarea name="description" class="form-control @error('description') is-invalid @enderror" placeholder="Ingrese una Descripción">{{$categories->description}}</textarea>

                    @error('description')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>

            <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                    <button type="submit" class="btn btn-primary">{{ __('Registrar') }}</button>
                    <a href="{{ route('Categories.index') }}" class="btn btn-danger" >Cancelar</a>
                </div>
            </div> 
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
 @endsection

resources/views/categories/index.blade.php
@extends('layouts.app')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">
  <!-- DataTales Example -->
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Lista de Categorías</h6>
    </div>
    <div class="card-body">
      <div class="table-responsive">
      <div class="btn-group">
      <a href="{{ route('Categories.create') }}" class="btn btn-info" data-toggle="modal" data-target="#ModalCreate"><i class="fa fa fa-plus-square"></i>&nbsp;&nbsp;Añadir Categoría</a>
      </div>
        <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
          <thead class="thead-light">
            <tr>
              <th>Nombre</th>
              <th>Descripción</th>
              <th>Editar</th>
              <th>Eliminar</th>
            </tr>
          </thead>
         <!-- <tfoot>
            <tr>
              <th>Nombre</th>
              <th>Descripción</th>
              <th>Editar</th>
              <th>Eliminar</th>
            </tr>
          </tfoot> -->
          <tbody>
            @if($categories->count())  
            @foreach($categories as $category)  
            <tr>
              <td>{{$category->name}}</td>
              <td>{{$category->description}}</td>

              <td style="width: 50px">
                <a class="btn btn-primary btn-2x" href="{{action('Categories\CategoriesController@edit', $category->id)}}">
                <i class="fa fa-pencil-square-o"></i></a>


              <td style="width: 50px">
                <form action="{{action('Categories\CategoriesController@destroy', $category->id)}}" method="post">
                 {{csrf_field()}}
                <input name="_method" type="hidden" value="DELETE">
                <button class="btn btn-danger btn-2x" type="submit"><i class="fa fa-bitbucket"></i></button>
                </form>
              </td>
            </tr>
             @endforeach 
             @else
             <tr>
              <td colspan="8">No hay Categorías creadas!</td>
            </tr>
            @endif
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>

<!--Modal Create Categories -->

  <!-- Modal -->
  <div class="modal fade" id="ModalCreate" role="dialog">
    <div class="modal-dialog modal-dialog-centered">
    
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
          <h4 class="modal-title">Crear Categoría</h4>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
        </div>
        <div class="modal-body">
          <form method="POST" action="{{ route('Categories.store') }}"  role="form">
           {{ csrf_field() }}

            <div class="form-group row">
                <label for="name" class="col-md-4 col-form-label text-md-right">Nombre<span class="required" style="color:red">*</span></label>

                <div class="col-md-6">
                    <input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old('name') }}" required autocomplete="name" autofocus>

                    @error('name')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>

             <div class="form-group row">
                <label for="name" class="col-md-4 col-form-label text-md-right">Descripcion<span class="required" style="color:red">*</span></label>

                <div class="col-md-6">
                    <textarea name="description" class="form-control @error('description') is-invalid @enderror" placeholder="Ingrese una Descripción"></textarea>

                    @error('description')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>

            <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                    <button type="submit" class="btn btn-primary">{{ __('Registrar') }}</button>
                    <button type="button" class="btn btn-danger" data-dismiss="modal">{{ __('Cerrar') }}</button>
                </div>
            </div> 
          </form>
          </div>
        </div>
     </div>
  </div>
<!--End Modal Create Categories -->


<script type="text/javascript">
  $(document).ready(function(){
     $('#dataTable').DataTable({
      "pageLength":5,
      "aLengthMenu": [[5,10,25, 50],[5,10,25, 50, "All"]],

        "language": {
            "url": "//cdn.datatables.net/plug-ins/9dcbecd42ad/i18n/Spanish.json"
        },

     }); 
  })
</script>

<!-- /.container-fluid -->
@endsection

resources/views/categories/show.blade.php
@extends('layouts.app')
 
@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2> Ver Categoría</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('Categories.index') }}"> Atrás</a>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Nombre:</strong>
                {{ $ Categories->name}}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Descripción:</strong>
                {{ $ Categories->description}}
            </div>
        </div>
    </div>
@endsection